package com.ebei.device.asset.weixin.contorller;

import com.baomidou.mybatisplus.plugins.Page;
import com.ebei.device.asset.weixin.model.entity.AssetTaskSignFile;
import com.ebei.device.asset.weixin.model.vo.AssetHistoryTask;
import com.ebei.device.asset.weixin.service.AssetTaskService;
import com.ebei.device.asset.weixin.util.ResponseEx;
import com.ebei.device.asset.weixin.util.ResponsePageEx;
import io.swagger.annotations.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.Map;

/**
 * @Description: ${资产任务 前端控制器}
 * @Date: 2020/8/12 16:55
 */
@RestController
@RequestMapping("/assetTask")
@Api(value = "assetTask", description = "资产任务")
public class AssetTaskController {


    @Autowired
    private AssetTaskService assetTaskService;


    @ApiOperation(value="获取隐患历史清单分页数据")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageSize", value = "URL参数：每页显示数量", required = false, paramType = "query"),
            @ApiImplicitParam(name = "pageIndex", value = "URL参数：当前页", required = false, paramType = "query"),
            @ApiImplicitParam(name = "tenantId", value = "租户Id", required = true, paramType = "query"),
            @ApiImplicitParam(name = "assetId", value = "资产Id", required = true, paramType = "query")
    })
    @GetMapping("/selectAssetTaskList")
    public ResponsePageEx<Object> selectAssetTaskList(@RequestParam(required = false) Integer pageSize, @RequestParam(required = false) Integer pageIndex,
                                                      @RequestParam Long tenantId, @RequestParam Long assetId) {

        Page<AssetHistoryTask> page = new Page<>(pageIndex == null ? 1 : pageIndex, pageSize == null ? Integer.MAX_VALUE : pageSize);
        Map<String,Object> params = new HashMap<>();
        params.put("tenantId",tenantId);
        params.put("assetId",assetId);
        Page<AssetHistoryTask> result = assetTaskService.selectAssetTaskList(page, params);
        return  ResponsePageEx.createSuccess(result.getRecords(), result.getTotal(), result.getCurrent(), result.getSize(), result.getPages());

    }

    @ApiOperation(value="保存任务签名")
    @PostMapping("/saveTaskSign")
    public ResponseEx<Object> saveTaskSign(@RequestBody @ApiParam(name="taskSignFile",value="参数JSON",required=true) AssetTaskSignFile taskSignFile) {

        assetTaskService.saveTaskSign(taskSignFile);
        return ResponseEx.createSuccess("签名成功");

    }



}
