package com.ebei.device.asset.weixin.model.entity;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableLogic;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * @Description: ${资产管理任务}
 * @Date: 2020/8/12 15:45
 */
@ApiModel("资产管理任务")
@TableName("tbg_asset_task")
@Data
public class AssetTask extends Model<AssetTask> {

    public static final int TASKTYPE_UNDONE = 0;         //任务类型--未完成
    public static final int TASKTYPE_FINISH = 1;         //任务类型--已完成
    public static final int TASKTYPE_TIMEOUT = 2;         //任务类型--已过期
    public static final int TASKTYPE_CLOSE = 3;         //任务类型--已关闭

    public static final int TASK_ON_LINE = 0;         //在线状态
    public static final int TASK_OFF_LINE = 1;         //离线状态


    public static final int TASK_SHOW_DAYS = 31;         //任务类型--待派单




    @ApiModelProperty(hidden=true)
    @TableId(value = "task_id",type = IdType.AUTO)
    private Long taskId;

    @ApiModelProperty(value = "计划id")
    @TableField(value = "plan_id")
    private Long planId;

    @ApiModelProperty(value = "资产id")
    @TableField(value ="asset_id")
    private Long assetId;

    @ApiModelProperty(value = "任务生成时间")
    @TableField(value = "create_date")
    private Date createDate;

    private Long creator;

    @TableField(value = "operate_date")
    private Date operateDate;

    @ApiModelProperty(value = "最终操作人Id")
    private Long operator;

    @ApiModelProperty(value = "任务状态0：未完成；1：已完成；2：已过期 3:已关闭")
    @TableField(value = "task_state")
    private Integer taskState;

    @ApiModelProperty(value = "任务开始时间")
    @TableField(value = "start_date")
    private Date startDate;

    @ApiModelProperty(value = "任务结束时间")
    @TableField(value = "end_date")
    private Date endDate;

    @ApiModelProperty(value = "检查地点，资产地址信息")
    @TableField(value = "location")
    private String location;

    @ApiModelProperty(hidden = true)
    @TableLogic
    private Integer state;          //数据状态标识  1 是

    @ApiModelProperty(value = "任务完成时添加的描述")
    @TableField(value = "task_remake")
    private String taskRemake;

    @TableField("company_id")
    @ApiModelProperty("公司Id")
    private Long companyId;

    @TableField("complete_time")
    @ApiModelProperty("任务完成的提交时间")
    private Date completeTime;

    @TableField("quality_category")
    @ApiModelProperty("资产管护:系统id")
    private Long qualityCategory;

    @TableField("submitter")
    @ApiModelProperty("完成提交人id")
    private Long submitter;

    @TableField("check_time")
    @ApiModelProperty("任务实际开始时间")
    private Date checkTime;

    @ApiModelProperty("合格率")
    @TableField("rate")
    private Double rate;

    @ApiModelProperty("pdfID")
    @TableField("task_pdf")
    private String taskPdf;

    @ApiModelProperty("版本号时间戳")
    @TableField("version")
    private Long version;

    @ApiModelProperty("是否计入统计内容,0 不要统计  1 需要统计,暂时弃用，手动排班和请假未同步实现观察设置，如需实现需通过定时器")
    @TableField("need_count")
    private Integer needCount;

    @ApiModelProperty("任务是否离线，0在线状态，1离线状态")
    @TableField("off_line_state")
    private Integer offLineState;

    //=============================================以下为非数据库字段======================================


    @Override
    protected Serializable pkVal() {
        return null;
    }
}
