package com.ebei.device.asset.weixin.model.entity;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * @Description: ${任务签名附件}
 */
@Data
@TableName("tbg_asset_task_sign_file")
@ApiModel("任务签名附件")
public class AssetTaskSignFile extends Model<AssetTaskSignFile> {

    @ApiModelProperty(hidden = true)
    @TableId(value = "file_id",type = IdType.ID_WORKER_STR)
    private String fileId;

    @ApiModelProperty(value = "创建时间")
    @TableField(value = "create_time")
    private Date createTime;

    @ApiModelProperty(value = "文件路径")
    @TableField(value = "file_path")
    private String filePath;

    @ApiModelProperty(value = "0:正常; 1:源文件未加密，疑似作弊; 2:源文件不存在，上传不成功")
    @TableField(value = "file_status")
    private Integer fileStatus;

    @ApiModelProperty(value = "1检查组签字；2受检单位负责人签字")
    @TableField(value = "file_type")
    private Integer fileType;

    @ApiModelProperty(value = "所属任务id")
    @TableField(value = "task_id")
    private Long taskId;

    public static final int SIGN_CHECK = 1;        //1检查组签字
    public static final int SIGN_TENANT = 2;       //2受检单位负责人签字



    @Override
    protected Serializable pkVal() {
        return null;
    }
}
