package com.ebei.device.asset.weixin.model.entity;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * @Description: ${任务租户签阅状态}
 */
@Data
@TableName("tbg_asset_task_sign_state")
@ApiModel("任务租户签阅状态")
public class AssetTaskSignState extends Model<AssetTaskSignState> {

    @ApiModelProperty(hidden = true)
    @TableId(value = "id",type = IdType.AUTO)
    private Long id;

    @ApiModelProperty(value = "任务Id")
    @TableField(value = "task_id")
    private Long taskId;

    @ApiModelProperty(value = "签阅状态")
    @TableField(value = "sign_state")
    private Integer signState;

    @ApiModelProperty(value = "签阅时间")
    @TableField(value = "sign_date")
    private Date signDate;

    @ApiModelProperty(value = "签阅租户")
    @TableField(value = "sign_tenant")
    private Long signTenant;



    public static final int SIGN_STATE_NO = 1;        //未签阅
    public static final int SIGN_STATE_YES = 2;        //已签阅


    @Override
    protected Serializable pkVal() {
        return null;
    }
}
