
package com.ebei.device.asset.weixin.model.vo;


import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableLogic;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.ebei.device.asset.weixin.model.entity.AssetUser;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * <p>
 * 资产管护租户账号信息VO
 * </p>
 *
 */
@Data
@NoArgsConstructor
@ApiModel("资产管护租户账号信息")
public class AssetTenantUserVO extends Model<AssetTenantUserVO> {

    public AssetTenantUserVO(String userAccount){
        this.userAccount = userAccount;
    }

    @ApiModelProperty(value="账号Id")
    private Long userId;

    @ApiModelProperty("账号")
    private String userAccount;

    @ApiModelProperty("用户姓名")
    private String userName;

    @ApiModelProperty("密码")
    private String pwd;

    @ApiModelProperty("新密码")
    private String newPwd;

    @ApiModelProperty("创建时间")
    private Date createDate;

    @ApiModelProperty("创建人")
    private Long creator;

    @ApiModelProperty("修改时间")
    private Date operateDate;

    @ApiModelProperty("修改人")
    private Long operator;

    @ApiModelProperty("公司id")
    private Long companyId;

    @ApiModelProperty("租户Id")
    private Long tenantId;

    @ApiModelProperty("租户名称")
    private String tenantName;

    @ApiModelProperty("联系方式")
    private String telephone;

    @ApiModelProperty("区域id")
    private Long areaId;

    @ApiModelProperty(value="数据状态  1：正常，0：删除 默认 1")
    private Integer state;

    @ApiModelProperty("暂存token")
    private String token;

    @ApiModelProperty("最近一次登录时间")
    private Date LastLoginDate;


    @ApiModelProperty(value="资产信息")
    private List<AssetUser> assetList;

    @ApiModelProperty("区域名称")
    private String areaName;





    @Override
    protected Serializable pkVal() {return null;}
	

}
