package com.ebei.device.asset.weixin.service.impl;

import com.baomidou.mybatisplus.plugins.Page;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.ebei.device.asset.weixin.auth.AuthUtils;
import com.ebei.device.asset.weixin.mapper.AssetTaskMapper;
import com.ebei.device.asset.weixin.mapper.AssetTaskSignFileMapper;
import com.ebei.device.asset.weixin.mapper.AssetTaskSignStateMapper;
import com.ebei.device.asset.weixin.model.entity.AssetTask;
import com.ebei.device.asset.weixin.model.entity.AssetTaskSignFile;
import com.ebei.device.asset.weixin.model.entity.AssetTaskSignState;
import com.ebei.device.asset.weixin.model.vo.AssetHistoryTask;
import com.ebei.device.asset.weixin.service.AssetTaskService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @Description: ${资产管理任务服务实现类}
 * @Date: 2020/8/12 16:53
 */
@Service
public class AssetTaskServiceImpl extends ServiceImpl<AssetTaskMapper, AssetTask> implements AssetTaskService {


    @Autowired
    AssetTaskSignFileMapper assetTaskSignFileMapper;
    @Autowired
    AssetTaskSignStateMapper assetTaskSignStateMapper;


    @Override
    public Page<AssetHistoryTask> selectAssetTaskList(Page<AssetHistoryTask> page, Map<String, Object> params) {

        params.put("companyId", AuthUtils.getCompanyId());
        List<AssetHistoryTask> list = this.baseMapper.selectAssetTaskList(page,params);
        return page.setRecords(list);
    }

    @Override
    public void saveTaskSign(AssetTaskSignFile taskSignFile) {

        //将该任务已有的同类型签名删除
        AssetTaskSignFile assetTaskSignFile = new AssetTaskSignFile();
        assetTaskSignFile.setTaskId(taskSignFile.getTaskId());
        assetTaskSignFile.setFileType(taskSignFile.getFileType());
        AssetTaskSignFile file = assetTaskSignFileMapper.selectOne(assetTaskSignFile);
        if(file != null){
            assetTaskSignFileMapper.deleteById(file);
        }

        Date now = new Date();
        //保存签名
        taskSignFile.setCreateTime(now);
        assetTaskSignFileMapper.insert(taskSignFile);

        //保存审阅状态信息
        AssetTaskSignState signState = new AssetTaskSignState();
        signState.setTaskId(taskSignFile.getTaskId());
        signState.setSignDate(now);
        signState.setSignState(AssetTaskSignState.SIGN_STATE_YES);
        signState.setSignTenant(AuthUtils.getUserId());
        assetTaskSignStateMapper.insert(signState);
    }
}
