package com.ebei.device.asset.weixin.util;

import lombok.extern.slf4j.Slf4j;
import org.springframework.web.context.request.RequestAttributes;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.net.URLEncoder;

@Slf4j
public class FileDownUtil {
	
	public final static String nofile = "<script>alert('无附件可供下载!');</script>";
	
	public static void downFile(byte[] bytes,String fname) {
		ServletRequestAttributes holder =  getRequestAttributes();
		HttpServletResponse response = holder.getResponse();
		if(bytes==null||bytes.length<=0) {
			nofile(response);
			return;
		}
		response.reset();
		response.setContentType("application/octet-stream");
		try {
//			HttpServletRequest request = holder.getRequest();
			String foname = null;
//			Object out = request.getAttribute(AuthUtils.REQ_BLANK);
//			if(out!=null) {
				foname = URLEncoder.encode(fname, "UTF-8");
//			}else {
//				foname = new String(fname.getBytes(),"ISO-8859-1");
//			}
			response.setHeader("Content-disposition", "attachment;filename="+foname);
			response.getOutputStream().write(bytes);
			response.flushBuffer();
			log.debug("[get] [sucess] [{}]",fname);
		}catch (Exception e) {
			log.error("[get] [error] ["+fname+"]",e);
		}
		
	}
	public static void downFile(InputStream file,String fname) {
		
		if(file!=null) {
			try {
                ByteArrayOutputStream bo = new ByteArrayOutputStream();
                byte[] data = new byte[1024];
                int length = 0;
                while((length = file.read(data)) > 0){
                    bo.write(data, 0, length);
                    bo.flush();
                }
                byte[] bytes = bo.toByteArray();
                downFile(bytes,fname);
				file.close();
			}catch (Exception e) {
				log.error("[get] [error] ["+fname+"]",e);
			}
		}else {
			nofile(getRequestAttributes().getResponse());
			log.warn("[get] [notfound] [{}]",fname);
		}
	}
	public static void downFile(File file,String fname) {
		if(fname==null) {
			fname = file.getName();
		}
		if(file.exists()&&file.isFile()) {
			try {
				FileInputStream fin = new FileInputStream(file);
				byte[] data = new byte[(int)file.length()];
				fin.read(data);
				downFile(data,fname);
				fin.close();
			}catch (Exception e) {
				log.error("[get] [error] ["+fname+"]",e);
			}
		}else {
			nofile(getRequestAttributes().getResponse());
			log.warn("[get] [notfound] [{}]",fname);
		}
	}
	private static void nofile(HttpServletResponse response) {
		response.setContentType("text/html;charset=utf-8");
		try {
			response.getWriter().write(nofile);
		} catch (IOException e) {}
	}
	/**
	 * 下载文件流
	 * @param file
	 */
	public static void downFile(File file) {
		downFile(file,null);
	}
    public static ServletRequestAttributes getRequestAttributes() {
    	RequestAttributes r = RequestContextHolder.currentRequestAttributes();
        return (ServletRequestAttributes)r;
    }
	public static String getFileName(String filename) {
		if (filename == null) {
			return "";
		}
		int unixSep = filename.lastIndexOf("/");
		int winSep = filename.lastIndexOf("\\");
		int pos = (winSep > unixSep ? winSep : unixSep);
		if (pos != -1)  {
			return filename.substring(pos + 1);
		}else {
			return filename;
		}
	}
}
